'***********************************************
'*  Frequency Counter                          *
'*  From Parallax Inc application note         *
'*  AN001 - Propeller Counters v1.1            *
'***********************************************


PUB start (freq_ptr) | freq
        cognew(@entry, freq_ptr)


DAT
        org     0

entry   mov     ctra, ctra_             'establish mode and start counter
        mov     frqa, #1                'increment for each edge seen
        mov     cnt_, cnt               'setup time delay
        add     cnt_, cntadd

:loop   waitcnt cnt_, cntadd            'wait for next sample
        mov     new, phsa               'record new count
        mov     temp, new               'make second copy
        sub     new, old                'get delta
        mov     old, temp               'set next delta's base

        wrlong  new, par
        jmp     #:loop

ctra_   long    %01010 << 26 + 16       'mode + APIN
cntadd  long    80_000_000              'wait 1 second, answer in Hz 

cnt_    res     1
new     res     1
old     res     1
temp    res     1
